require 'uu/os/rest/dto'
require 'uu/os/uesuri'

# Module Unicorn Universe.
module UU
  # Module Operating System.
  module OS
    # Activity.
    module Activity
      # @see Activity#set_state
      class ActivitySetState < UU::OS::REST::DTO

        # @see Activity#set_state
        attr_accessor :template_uri

        # @see Activity#set_state
        attr_accessor :type

        # @see Activity#set_state
        attr_accessor :subtype
        
        # @see Activity#set_state
        attr_accessor :comment
        
        def template_uri 
          attributes[:templateUri]
        end

        def template_uri=(val) 
          if val
            attributes[:templateUri] = UU::OS::UESURI.new(val)
          else
            attributes[:templateUri] = nil
          end
        end

        def type 
          attributes[:type]
        end

        def type=(val) 
          attributes[:type] = val
        end

        def subtype 
          attributes[:subtype]
        end

        def subtype=(val) 
          attributes[:subtype] = val
        end

        def comment 
          attributes[:comment]
        end

        def comment=(val) 
          attributes[:comment] = val
        end

      end
    end

  end
end
