require 'uu/os/rest/dto'
require 'uu/os/uesuri'


# Module Unicorn Universe.
module UU
  # Module Operating System.
  module OS
    # Module Activity State Template.
    module ActivityStateTemplate
      # @see ActivityStateTemplate#set_attributes
      class ActivityStateTemplateSetAttributes < UU::OS::REST::DTO

        # @see ActivityStateTemplate#set_attributes
        attr_accessor :name

        # @see ActivityStateTemplate#set_attributes
        attr_accessor :code

        # @see ActivityStateTemplate#set_attributes
        attr_accessor :description

        # @see ActivityStateTemplate#set_attributes
        attr_accessor :subtype

        # @see ActivityStateTemplate#set_attributes
        attr_accessor :entry_state

        # @see ActivityStateTemplate#set_attributes
        attr_accessor :exit_state

        # @see ActivityStateTemplate#set_attributes
        attr_accessor :icon_uri

        # @see ActivityStateTemplate#set_attributes
        attr_accessor :order

        # @see ActivityStateTemplate#set_attributes
        attr_accessor :participants

        # @see ActivityStateTemplate#set_attributes
        attr_accessor :digital_workspace_visibility

        def name
          attributes[:name]
        end

        def name=(val)
          attributes[:name] = val
        end

        def code
          attributes[:code]
        end

        def code=(val)
          attributes[:code] = val
        end

        def description
          attributes[:description]
        end

        def description=(val)
          attributes[:description] = val
        end

        def subtype
          attributes[:subtype]
        end

        def subtype=(val)
          attributes[:subtype] = val
        end

        def entry_state
          attributes[:entryState]
        end

        def entry_state=(val)
          attributes[:entryState] = val
        end

        def exit_state
          attributes[:exitState]
        end

        def exit_state=(val)
          attributes[:exitState] = val
        end

        def icon_uri
          attributes[:iconUri]
        end

        def icon_uri=(val)
          if val
            attributes[:iconUri] = UU::OS::UESURI.new(val)
          else
            attributes[:iconUri] = nil
          end
        end

        def order
          attributes[:order]
        end

        def order=(val)
          attributes[:order] = val
        end

        def participants
          attributes[:participants]
        end

        def participants=(val)
          attributes[:participants] = val
        end

        def digital_workspace_visibility
          attributes[:digitalWorkspaceVisibility]
        end

        def digital_workspace_visibility=(val)
          attributes[:digitalWorkspaceVisibility] = val
        end

      end
    end

  end
end
