require 'uu/os/rest/dto'
require 'uu/os/uesuri'


module UU
  module OS

    module Friend
      class FriendSetAttributes < UU::OS::REST::DTO

        # @see Friend#set_attributes
        attr_accessor :first_name

        # @see Friend#set_attributes
        attr_accessor :surname

        # @see Friend#set_attributes
        attr_accessor :code

        # @see Friend#set_attributes
        attr_accessor :description

        # @see Friend#set_attributes
        attr_accessor :security_level

        # @see Friend#set_attributes
        attr_accessor :icon_uri



        def first_name
          attributes[:firstName]
        end

        def first_name=(val)
          attributes[:firstName] = val
        end

        def surname
          attributes[:surname]
        end

        def surname=(val)
          attributes[:surname] = val
        end

        def code
          attributes[:code]
        end

        def code=(val)
          attributes[:code] = val
        end

        def description
          attributes[:description]
        end

        def description=(val)
          attributes[:description] = val
        end

        def security_level
          attributes[:securityLevel]
        end

        def security_level=(val)
          attributes[:securityLevel] = val
        end

        def icon_uri
          attributes[:iconUri]
        end

        def icon_uri=(val)
          if val
            attributes[:iconUri] = UU::OS::UESURI.new(val)
          else
            attributes[:iconUri] = nil
          end
        end

      end
    end

  end
end