require 'uu/os/rest/dto'
require 'uu/os/uesuri'

# Module Unicorn Universe.
module UU
  # Module Operating System.
  module OS
    # Module Meta Permission.
    module MetaPermission
      # DTO containing attributes of the meta permission.
      class MetaPermissionGetMaskAttributes < UU::OS::REST::DTO

        # UESURI of the meta permission.
        attr_accessor :uri

        # Name of the meta permission.
        attr_accessor :name

        # Code of the meta permission.
        attr_accessor :code

        # Description of the meta permission.
        attr_accessor :description

        # Flag indicating whether the permission mask is set as default for the template for which the mask is defined.
        attr_accessor :default_mask

        # Creation tome of the meta permission.
        attr_accessor :creation_time

        # Creation stamp of the meta permission.
        attr_accessor :creation_stamp

        # Modification time of the meta permission.
        attr_accessor :modification_time

        # Modification stamp of the meta permission.
        attr_accessor :modification_stamp

        # Version of the meta permission.
        attr_accessor :version

        # Labels of the meta permission in different languages.
        attr_accessor :labels
        def uri
          attributes[:uri]
        end

        def uri=(val)
          if val
            attributes[:uri] = UU::OS::UESURI.new(val)
          else
            attributes[:uri] = nil
          end
        end

        def name
          attributes[:name]
        end

        def name=(val)
          attributes[:name] = val
        end

        def code
          attributes[:code]
        end

        def code=(val)
          attributes[:code] = val
        end

        def description
          attributes[:description]
        end

        def description=(val)
          attributes[:description] = val
        end

        def default_mask
          attributes[:defaultMask]
        end

        def default_mask=(val)
          attributes[:defaultMask] = val
        end

        def creation_time
          attributes[:creationTime]
        end

        def creation_time=(val)
          attributes[:creationTime] = val
        end

        def creation_stamp
          attributes[:creationStamp]
        end

        def creation_stamp=(val)
          attributes[:creationStamp] = val
        end

        def modification_time
          attributes[:modificationTime]
        end

        def modification_time=(val)
          attributes[:modificationTime] = val
        end

        def modification_stamp
          attributes[:modificationStamp]
        end

        def modification_stamp=(val)
          attributes[:modificationStamp] = val
        end

        # @deprecated Use {MetaPermissionGetMaskAttributes#version} instead.
        def revision 
          attributes[:version]
        end

        # @deprecated Use {MetaPermissionGetMaskAttributes#version} instead.
        def revision=(val) 
          attributes[:version] = val
        end

        def version 
          attributes[:version]
        end

        def version=(val) 
          attributes[:version] = val
        end

        def labels
          attributes[:labels]
        end

        def labels=(val)
          attributes[:labels] = val
        end

      end
    end

  end
end

