require 'uu/os/rest/dto'

module UU
  module OS
    module UseCaseRealization
      # @deprecated Use {UU::OS::VisualUseCase::VisualUseCaseGetUseCaseListItem} instead.
      class UseCaseRealizationGetUseCaseListItem < UU::OS::REST::DTO

        # Code of the connected use case. Never null.
        attr_accessor :code

        # Name of the connected use case. Never null.
        attr_accessor :name

        # Normalized UESURI of the connected use case. Never null.
        attr_accessor :uri

        # UESURI of the entity type of the use case. Never null.
        attr_accessor :entity_type_uri
        def code
          attributes[:code]
        end

        def code=(val)
          attributes[:code] = val
        end

        def name
          attributes[:name]
        end

        def name=(val)
          attributes[:name] = val
        end

        def uri
          attributes[:uri]
        end

        def uri=(val)
          if val
            attributes[:uri] = UU::OS::UESURI.new(val)
          else
            attributes[:uri] = nil
          end
        end

        def entity_type_uri
          attributes[:entityTypeUri]
        end

        def entity_type_uri=(val)
          if val
            attributes[:entityTypeUri] = UU::OS::UESURI.new(val)
          else
            attributes[:entityTypeUri] = nil
          end
        end

      end
    end

  end
end
